#!/usr/bin/env python

import __version__
__version__ = __version__.ver

from wxPython.wx import *
from App import *
from About import AboutBox
from Help import HelpBox
from tempfile import mktemp
import ftplib
import string
import os

# your favorite editor
EDITOR_CMD = 'xjed %s -l ./zope.sl'
# host port username password
LOGIN_CMD = 'localhost 8021 admin yourpassword'
# where to download files
DOWNLOAD_PATH = './'
# no need to change this
TMP_FILE_SUFFIX = 'ze'

ZopeEDIT_menu = """<?xml version="1.0"?>
<wxappdef title="ZopeEDIT" wide="600" high="400" statusbar="default">
  <menudef>
    <menu name="&amp;File">
       <menuitem name="&amp;Open" accel="Ctrl-O" id="1001" tip="Connect to Medusa" />
       <menuitem name="&amp;Close" id="1004" tip="Close connection" />
       <menuseparator />
       <menuitem name="E&amp;xit" accel="Ctrl-X" id="1006" />
    </menu>
    <menu name="&amp;Edit">
       <menuitem name="&amp;New" accel="Ctrl-N" id="2001" tip="Add new DTML Document" />
       <menuseparator />
       <menuitem name="Cu&amp;t" accel="Alt-X" id="2002" tip="Delete this document" />
       <menuitem name="&amp;Copy" accel="Alt-C" id="2003" tip="Delete and save this document" />
       <menuitem name="&amp;Paste" accel="Alt-V" id="2004" tip="Paste this document" />
    </menu>
    <menu name="&amp;Help">
       <menuitem name="&amp;Help" accel="F1" id="3001" tip="Get help now!" />
       <menuseparator />
       <menuitem name="&amp;About" id="3002" tip="Who dunnit" />
    </menu>
  </menudef>
  <toolbar>
    <toolbaritem name="Open" bitmap="Open" id="1001" tip="Open connection" />
    <toolbaritem name="Close" bitmap="Close" id="1004" tip="Close connection" />
    <toolbarseparator />
    <toolbaritem name="New" bitmap="New" id="2001" tip="New DTML document" />
    <toolbaritem name="Cut" bitmap="Cut" id="2002" tip="Cut document" />
    <toolbaritem name="Copy" bitmap="Copy" id="2003" tip="Copy document" />
    <toolbaritem name="Paste" bitmap="Paste" id="2004" tip="Paste document" />
  </toolbar>
</wxappdef>
"""

# ========================================================================
class wxFTP( App ):
    def __init__( self, resource ):
	self._ftp = ftplib.FTP()
	self._root = None
	# for the progress bar
	self._progress = None
	self._currentsize = 0
	
	App.__init__( self, resource )
	
	self._img_list = wxImageList( 16, 16 )
	self.img_folder  = self._img_list.Add(wxBitmap('Images/folder.bmp', wxBITMAP_TYPE_BMP))
	self.img_folder_open  = self._img_list.Add(wxBitmap('Images/folder-open.bmp', wxBITMAP_TYPE_BMP))
	
	splitter = wxSplitterWindow( self, -1 )
	tID = wxNewId()
	self.tree = wxTreeCtrl( splitter, tID )
	self.tree.SetImageList( self._img_list )
	EVT_TREE_ITEM_EXPANDED( self.tree, tID, self.OnItemExpanded )
	EVT_TREE_ITEM_COLLAPSED( self.tree, tID, self.OnItemCollapsed )
	EVT_TREE_SEL_CHANGED( self.tree, tID, self.OnTreeSelChanged )
	
	listID = wxNewId()
	self.flist = wxListBox( splitter, listID, wxDefaultPosition, wxDefaultSize, [], wxLB_SINGLE )
	EVT_LISTBOX_DCLICK( self.flist, listID, self.OnListDClick )
	EVT_RIGHT_UP( self.flist, self.OnListRightClick )
	
	splitter.SplitVertically( self.tree, self.flist )
	splitter.SetSashPosition( 180, true )
	splitter.SetMinimumPaneSize( 20 )
	self.DisableCmd( 'New' )
	self.DisableCmd( 'Cut' )
	self.DisableCmd( 'Copy' )
	self.DisableCmd( 'Paste' )
	self.DisableCmd( 'Close' )
	self.SetTitle( 'ZopeEDIT: *not connected*' )
	
    # --------------------------------------------------------------------
    def OnListRightClick( self, event ):
	sel = self.flist.GetSelection()
	fname = self.flist.GetString( sel )
	if sel == -1:
	    return
	if event.ShiftDown():
	    self.Download( fname )
	else:
	    if self.getFileInfo( fname ):
		info = self._fileinfo
		dlg = wxMessageDialog( self, 'Name: %s\nOwner: %s\nGroup: %s\nSize: %s\nPerms: %s' % (info[8], info[2], info[3], info[4], info[0]), 'File Info', wxOK | wxICON_INFORMATION )
		dlg.ShowModal()
		dlg.Destroy()
	    	    
    # --------------------------------------------------------------------
    def Download( self, fname ):
	fsize = 0
	if self.getFileInfo( fname ):
	    fsize = int(self._fileinfo[4])
	    self._progress = wxProgressDialog( 'Download: %s' % fname, '', fsize, self, wxPD_AUTO_HIDE | wxPD_APP_MODAL )
	    self._currentsize = 0
	try:
	    self._fp = open( DOWNLOAD_PATH + fname, 'w' )
	    self._ftp.retrbinary( 'RETR %s' % fname, self._saveFile_cb )
	    self._fp.close()
	    if self._progress != None:
		self._progress.Destroy()
		self._progress = None
	    dlg = wxMessageDialog( self, 'Download complete\n%s' % fname, 'Download', wxOK | wxICON_INFORMATION )
	    dlg.ShowModal()
	    dlg.Destroy()
	except ftplib.error_perm, msg:
	    if self._progress != None:
		self._progress.Destroy()
		self._progress = None
	    dlg = wxMessageDialog( self, msg, 'FTP Error', wxOK | wxICON_ERROR )
	    dlg.ShowModal()
	    dlg.Destroy()

    # --------------------------------------------------------------------
    def getFileInfo( self, fname ):
	self._fileinfo = []
	list = self._ftp.retrlines( 'LIST %s' % fname, self._getFileInfo_cb )
	if len( self._fileinfo ):
	    return 1
	return 0
	

    # --------------------------------------------------------------------
    def _getFileInfo_cb( self, line ):
	info = string.split( line )
	if len( info[0] ) == 10:
	    self._fileinfo = info
	
	
    # --------------------------------------------------------------------
    def OnListDClick( self, event ):
	sel = self.flist.GetSelection()
	if sel == -1:
	    return
	fname = self.flist.GetString( sel )
	tmpfile = mktemp(TMP_FILE_SUFFIX)
	self._fp = open( tmpfile, 'w' )
	try:
	    self._ftp.retrbinary( 'RETR %s' % fname, self._saveFile_cb )
	    self._fp.close()
	    os.system( EDITOR_CMD % tmpfile )
	    dlg = wxMessageDialog( self, 'Save "%s" to Zope?' % ( fname ), 'Save', wxYES_NO | wxICON_QUESTION )
	    if dlg.ShowModal() == wxID_YES:
		try:
		    self._fp = open( tmpfile, 'r' )
		    self._ftp.storbinary( 'STOR %s' % fname, self._fp, 8192 )
		    self._fp.close()
		except ftplib.error_temp, msg:
		    dl1 = wxMessageDialog( self, msg + '\n[%s]' % fname, 'FTP Error', wxOK | wxICON_ERROR )
		    dl1.ShowModal()
		    dl1.Destroy()
	    dlg.Destroy()
	    os.unlink( tmpfile )
	except ftplib.error_perm, msg:
	    dlg = wxMessageDialog( self, msg, 'FTP Error', wxOK | wxICON_ERROR )
	    dlg.ShowModal()
	    dlg.Destroy()

    # --------------------------------------------------------------------
    def OnCut( self, event ):
	fname = self.flist.GetString(self.flist.GetSelection())
	tmpname = mktemp(TMP_FILE_SUFFIX)
	self._fp = open( tmpname, 'w' )
	try:
	    self._ftp.retrbinary( 'RETR %s' % fname, self._saveFile_cb )
	    self._fp.close()
	    self._ftp.delete( fname )
	    self._edit_info = []
	    self._edit_info.append( tmpname )
	    self._edit_info.append( fname )
	    self.EnableCmd( 'Paste' )
	    self.getFileList()
	except ftplib.error_perm, msg:
	    dlg = wxMessageDialog( self, msg, 'FTP Error', wxOK | wxICON_ERROR )
	    dlg.ShowModal()
	    dlg.Destroy()

    # --------------------------------------------------------------------
    def OnCopy( self, event ):
	fname = self.flist.getString(self.flist.GetSelection())
	tmpname = mktemp(TMP_FILE_SUFFIX)
	self._fp = open( tmpname, 'w' )
	try:
	    self._ftp.retrbinary( 'RETR %s' % fname, self._saveFile_cb )
	    self._fp.close()
	    self._edit_info = []
	    self._edit_info.append( tmpname )
	    self._edit_info.append( fname )
	    self.EnableCmd( 'Paste' )
	except ftplib.error_perm, msg:
	    dlg = wxMessageDialog( self, msg, 'FTP Error', wxOK | wxICON_ERROR )
	    dlg.ShowModal()
	    dlg.Destroy()
    
    # --------------------------------------------------------------------
    def OnPaste( self, event ):
	tmpname = self._edit_info[0]
	fname  = self._edit_info[1]
	try:
	    self._fp = open( tmpname, 'r' )
	    self._ftp.storbinary( 'STOR %s' % fname, self._fp, 8192 )
	    self._fp.close()
	    self.getFileList()
	except ftplib.error_perm, msg:
	    dlg = wxMessageDialog( self, msg, 'FTP Error', wxOK | wxICON_ERROR )
	    dlg.ShowModal()
	    dlg.Destroy()
    
    # --------------------------------------------------------------------
    def OnNew( self, event ):
	tmpfile = mktemp(TMP_FILE_SUFFIX)
	self._fp = open( tmpfile, 'w' )
	self._fp.write( '<dtml-var standard_html_header>\n' )
	self._fp.write( '<h2>FIX ME</h2>\n' )
	self._fp.write( '<dtml-var standard_html_footer>\n' )
	self._fp.close()
	try:
	    os.system( EDITOR_CMD % tmpfile )
	    dlg = wxTextEntryDialog( self, 'Document name', 'Save As', 'new_dtml' )
	    if dlg.ShowModal() == wxID_OK:
		fname = dlg.GetValue()
		try:
		    self._fp = open( tmpfile, 'r' )
		    self._ftp.storbinary( 'STOR %s' % fname, self._fp, 8192 )
		    self._fp.close()
		except ftplib.error_temp, msg:
		    dl1 = wxMessageDialog( self, msg + '\n[%s]' % fname, 'FTP Error', wxOK | wxICON_ERROR )
		    dl1.ShowModal()
		    dl1.Destroy()
	    dlg.Destroy()
	    os.unlink( tmpfile )
	    self.getFileList()
	except ftplib.error_perm, msg:
	    dlg = wxMessageDialog( self, msg, 'FTP Error', wxOK | wxICON_ERROR )
	    dlg.ShowModal()
	    dlg.Destroy()
	    
    # --------------------------------------------------------------------
    def _saveFile_cb( self, data ):
	self._fp.write( data )
	if self._progress != None:
	    self._currentsize = self._currentsize + len(data)
	    self._progress.Update( self._currentsize )
	    
    # --------------------------------------------------------------------
    def OnItemExpanded( self, event ):
	item = event.GetItem()
	
    # --------------------------------------------------------------------
    def OnItemCollapsed( self, event ):
	item = event.GetItem()
	
    # --------------------------------------------------------------------
    def OnAbout( self, event ):
	dlg = AboutBox( self )
	dlg.ShowModal()
	dlg.Destroy()
		    	
    # --------------------------------------------------------------------
    def OnHelp( self, event ):
	dlg = HelpBox( self )
	dlg.ShowModal()
	dlg.Destroy()
	
    # --------------------------------------------------------------------
    def OnTreeSelChanged( self, event ):
	# wxPython changed to GetItemParent in version 2.1.13
	if wxc.__version__ >= '2.1.13':
	    git = self.tree.GetItemParent
	else:
	    git = self.tree.GetParent
	item = event.GetItem()
	parent = git( item )
	path = '/' 
	if self.tree.GetItemText(item) != '/':
	    path = path + self.tree.GetItemText(item)
	while len(self.tree.GetItemText(parent)):
	    path = '/' + self.tree.GetItemText(parent) + path
	    parent = git( parent )
	self.tree.CollapseAndReset( item )
	self._curdir = item
	self.getFileList( path )
	
    # --------------------------------------------------------------------
    def OnOpen( self, event ):
	dlg = wxTextEntryDialog( self, 'Connect to: (host port user passwd)', 'Connect', LOGIN_CMD )
	if dlg.ShowModal() == wxID_OK:
	    vals = string.split( dlg.GetValue() )
	    self.SetTitle( 'ZopeEDIT: %s:%s' % (vals[0], vals[1]) )
	    self._ftp.connect( vals[0], int(vals[1]))
	    self._ftp.login( vals[2], vals[3] )
	    self.flist.Clear()
	    self.tree.DeleteAllItems()
	    self._root = self.tree.AddRoot( '/' )
	    self._curdir = self._root
	    self.getFileList('/')
	    self.EnableCmd( 'New' )
	    self.EnableCmd( 'Cut' )
	    self.EnableCmd( 'Copy' )
	    self.EnableCmd( 'Close' )
	dlg.Destroy()
	
    # --------------------------------------------------------------------
    def OnClose( self, event ):
	self.flist.Clear()
	self.tree.DeleteAllItems()
	self.SetTitle( 'ZopeEDIT: *not connected*' )
	self.DisableCmd( 'New' )
	self.DisableCmd( 'Cut' )
	self.DisableCmd( 'Copy' )
	self.DisableCmd( 'Close' )
	self._ftp.close()
    
    # --------------------------------------------------------------------
    def getFileList( self, path=None ):
	self.flist.Clear()
	if path:
	    self._ftp.cwd( path )
	list = self._ftp.retrlines( 'LIST', self.addFile )
	self.tree.Expand( self._curdir )
	
    # --------------------------------------------------------------------
    def addFile( self, line ):
	info = string.split( line )
	fname = info[len(info)-1]
	if info[0][0] != 'd':
	    self.flist.Append( fname )
	elif len(fname) and fname != '..' :
	    item = self.tree.AppendItem( self._curdir, fname )
	    self.tree.SetItemImage( item, self.img_folder )
	    self.tree.SetItemSelectedImage( item, self.img_folder_open )
	    
# ========================================================================
class mApp( wxApp ):
    def OnInit( self ):
	frame = wxFTP( ZopeEDIT_menu )
	frame.Show(true)
	self.SetTopWindow(frame)
	return true

def main():
    app = mApp(0)
    app.MainLoop()
    
# ========================================================================
# ------------------------------------------------------------------------
if __name__ == '__main__':
    main()
